/*
pot 2 est un programme servant  lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
selon les termes de la Licence Publique Gnrale GNU publie par la
Free Software Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but
spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus
de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en
mme temps que ce programme ; si ce n'est pas le cas, crivez  la
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr */

#include "commun.h"
#include "console.h"
#include "main.h"

char couleurs_const_ref[NB_COULEUR+1][TAILLE_CONST_COULEUR] = { 
  "\033[30;42m", 
  "\033[30;43m", 
  "\033[30;41m",
  "\033[0m"
};


void build_affichage_s(struct affichage_s *affichage)
{
  int i = 0;

  if (IS_OPTION_SET(OPTION_HIDEDOUBLE))
    {
	 ADD_FIRST_LINE("Login", 11, VERT, 0, 0, LEFT);
    }
  else
    {
	 ADD_FIRST_LINE("Login", 8, VERT, 0, 0, LEFT);
    }

  ADD_FIRST_LINE("Talk", 6, VERT, 0, 0, CENTER);
  
  if (IS_OPTION_NOT_SET(OPTION_HIDEIDLE))
    {
	 ADD_FIRST_LINE("Idle", 6, VERT, 0, 0, RIGHT);
    }

  ADD_FIRST_LINE("Nom", 25, JAUNE, 2, 1, LEFT);
	   
  if (IS_OPTION_SET(OPTION_SHOWCOMP))
    {
	 ADD_FIRST_LINE("Ordi", 20, ROUGE, 2, 1, LEFT);
    }
  else
    {
	 ADD_FIRST_LINE("Salle", 20, ROUGE, 2, 1, LEFT);
    }

  END_FIRST_LINE;
}

int centrer(char *chaine, int taille)
{
  char tmp[80];

  
  int nb_espace;
  int i,j = 0;

  if(taille >= 80)
    {
	 printf("Taille du champs invalide\n");
	 return 0;
    }

  nb_espace = (taille - strlen(chaine));


  for(i = 0; i < nb_espace / 2; i++)
    tmp[i] = ' ';

  strcpy(tmp+i,chaine);

  j = i + strlen(chaine);

  for(; j < taille; j++)
    tmp[j] = ' ';

  tmp[j] = '\0';

  
  strcpy(chaine,tmp);

  return 1;
}

int right(char *chaine, int taille)
{
  char tmp[80];

  
  int nb_espace;
  int i,j = 0;

  if(taille >= 80)
    {
	 printf("Taille du champs invalide\n");
	 return 0;
    }

  nb_espace = (taille - strlen(chaine)-1);


  for(i = 0; i < nb_espace; i++)
    tmp[i] = ' ';

  strcpy(tmp+i,chaine);

  j = i + strlen(chaine);

  tmp[j] = ' ';
  tmp[j+1] = '\0';

  strcpy(chaine,tmp);

  return 1;
}

int left(char *chaine, int taille, int nbspaces)
{
  int i;

  char tmp[80];

  for(i = 0; i < nbspaces; i++)
    tmp[i] = ' ';

  for(i = 0; i < strlen(chaine); i++)
    tmp[i+nbspaces] = chaine[i];

  for(i = strlen(chaine); i < taille-nbspaces; i++)
    tmp[i+nbspaces] = ' ';

  tmp[taille] = '\0';

  strncpy(chaine, tmp, taille+1);

  return 1;
}

void premiere_ligne(char ** couleurs, struct affichage_s *affichage)
{
  char ligne[256];
  char ajout[256];

  ligne[0] = '\0';

  while(affichage->titre[0] != '\0')
    {
      ajout[0] = '\0';

      strcat(ajout, affichage->titre);

	 if(affichage->flags & CENTER)
	   centrer(ajout, affichage->taille);
	 else if(affichage->flags & RIGHT)
	   right(ajout, affichage->taille);
	 else if(affichage->flags & LEFT)
	   left(ajout, affichage->taille, affichage->nbspaces_titre);

	 sprintf(ajout, "%s%s%s",couleurs[affichage->couleur],ajout,couleurs[C_REINIT]);

      strcat(ligne, ajout);
      affichage++;
    }
  printf("%s\n", ligne);
}

void affichage_pot(char ** couleurs, struct affichage_s *affichage, 
		  struct liste_connecte *connecte)
{
  char ligne[256];
  char ajout[256];
  
  char talk[2];

  ligne[0] = '\0';

  if ( connecte->talk == 2)
    talk[0] = 'w'; /* w comme Windows (samba) */
  else if ( connecte->talk == 3)
	    talk[0] = 'x'; /* x comme xdm (log graphique) */
  else if ( connecte->talk == 1)
    talk[0] = '+';
  else
    talk[0] = '-';

  talk[1] = '\0';

  while(affichage->titre[0] != '\0')
    {
      ajout[0] = '\0';

      if(!strcmp(affichage->titre, "Login"))
	   {
		strcat(ajout, connecte->login);
	   }
      else if(!strcmp(affichage->titre, "Talk"))
	   {
		strcat(ajout,talk);
	   }
      else if(!strcmp(affichage->titre, "Idle"))
	   strcat(ajout,print_idle(connecte->idle));
      else if(!strcmp(affichage->titre, "Nom"))
	   strcat(ajout,connecte->nom);
      else if(!strcmp(affichage->titre, "Salle"))
	   strcat(ajout,connecte->salle);
      else if(!strcmp(affichage->titre, "Ordi"))
	   strcat(ajout,connecte->ordi);
	 

	 if(affichage->flags & CENTER)
	   centrer(ajout, affichage->taille);
	 else if(affichage->flags & RIGHT)
	   right(ajout, affichage->taille);
	 else if(affichage->flags & LEFT)
	   left(ajout, affichage->taille, affichage->nbspaces_ligne);

	 
      strncat(ligne, ajout, affichage->taille);
      affichage++;
    }

  printf("%s\n", ligne);
}

void console ( char *chemin )
{
  int compteur,i;
  
  char *couleurs_const[NB_COULEUR+1];
  char no_couleur = '\0';

  struct affichage_s  affichage[MAX_ELEMENTS_AFFICHAGE];

  compteur = recherche_pots(chemin);

  /* initialisation de la structure */
  connecte = &depart;

  if ( compteur > 0 )
    {
      if ( options & OPTION_COULEUR )
	{
	  for(i = 0; i < NB_COULEUR + 1; i++)
	    couleurs_const[i] = couleurs_const_ref[i];
	}
      else
	{
	  for(i = 0; i < NB_COULEUR+1; i++)
	    couleurs_const[i] = &no_couleur;
	}
      
      build_affichage_s(affichage);

      if(IS_OPTION_NOT_SET(OPTION_QUIET))
	premiere_ligne(couleurs_const, affichage);

      while ( (connecte = connecte->next) )
	   {
		affichage_pot(couleurs_const, affichage, connecte);
	   }
    }
  else
    {
      printf ("Pas de \"pot\" trouv.\n");
    }
}




