/*
est pot un programme servant  lister vos "pot" sur un rseau
Copyright (C) 2001 Fabien Carrion et Guillaume Pinot

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les
termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but
spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus
de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.

fcarrion@etu.utc.fr
pinotgui@etu.utc.fr
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "console.h"
#include "commun.h"
#include "main.h"

#ifdef GTKUSE
#include "potgtk.h"
#endif

int options;

void usage (char *nom)
{
	printf("Pot %s par Fabien Carrion et Guillaume Pinot\n"
	       "G.U.I. par Tahorg\n"
	       "Participation de Bertrand Bonnafous\n\n"
	       "utilisation : %s [-acghilq] [login1 [login2...] [ -r login ];\n"
	       "\tlogin1 login2\trajoute des logins dans votre liste de \"pot\" ;\n"
	       "\t-a\t\taffiche la liste des personnes connectes\n"
	       "\t-c\t\tlance pot sans la couleur ;\n"
#ifdef GTKUSE
	       "\t-g\t\tlance potgtk, la version Graphique ;\n"
#endif
	       "\t-h\t\taffiche ce message d'aide ;\n"
	       "\t-i\t\tmasque l'idle ;\n"
	       "\t-l\t\taffiche votre liste de \"pots\" ;\n"
	       "\t-p\t\taffiche le nom de la machine plutot que la salle ;\n"
	       "\t-q\t\tmasquer la barre de titre ;\n"
	       "\t-r\t\tenlve un login de votre liste de \"pot\" ;\n"
	       "\t-u\t\taffiche seulement les personnes connectes depuis un terminal ;\n"
#ifdef SAMBA
	       "\t-w\t\taffiche seulement les personnes utilisant samba ;\n"
#endif
	       "Pour pouvoir personnalis son pot, il faut lire le fichier de configuration par dfaut\n"
	       "\n\thttp://wwwetu.utc.fr/~pinotgui/\n\n",VERSION,nom);

}

/* fonction de traitement des options 
   /!\ on suppose que le fichier .pot.pot existe /!\

   retourne :

   -1 : si on doit arreter l'execution
   0 : sinon
*/
int reconnaissance_options(int argc, char **argv, char *chemin)
{
  char c;
  FILE *pot;
  int i;

  /* initialisation de la variable options */
  options = 0x0 | OPTION_COULEUR;

  opterr = 0;

  /* Les arguments */
  while ( ( c = getopt(argc,argv,"hlgcpiduwaqr:") ) != -1 ) 
    {
	 switch ( c )
	   {
		/* aide */
	   case 'h' :
	     usage(argv[0]);
	     return -1;
	     /* lance la version sans couleur */
	     
	   case 'c' :
	     options &= ~OPTION_COULEUR;
	     break;
		
#ifdef GTKUSE
		/* Lance potgtk (en graphique) */
	   case 'g' :
	     options |= OPTION_GTK;
	     break;
#endif
	   case 'q':
	     options |= OPTION_QUIET;
	     break;
		
		/* visualisation des logins enregistrs pour localhost */
	   case 'l' :
	     options |= OPTION_LISTEPOTS;
	     break;
	
	/* visualisation des logins enregistrs pour linux
	   case 't' :
	   strcat(chemin,".linux");
	   view(chemin);
	   return 0; */
	
		/* suppression d'un login pour localhost */
	   case 'r' :
	     printf("Suppression d'un pot : %s\n", optarg);
	     suppr(chemin,optarg);
	     return -1;
	     
	   case 'd':
	     options |= OPTION_HIDEDOUBLE;
	     break;

	   case 'i':
	     options |= OPTION_HIDEIDLE;
	     break;

	   case 'p':
	     options |= OPTION_SHOWCOMP;
	     break;

	   case 'w':
#ifdef SAMBA
	     options |= OPTION_ONLYSAMBA;
#else
	     printf("Le support de Samba n'est pas integr, ");
	     printf("l'option -w est ignor\n");
#endif
	     break;
	     
	   case 'u':
	     options |= OPTION_ONLYTERM;
	     break;

	   case 'a':
	     options |= OPTION_SHOWALL;
	     break;

		/* arguments invalide */
	   default  :
		printf("Argument invalide, tapez %s -h pour avoir de l'aide\n",argv[0]);
		return -1;
	   }
    }

  /* On n'a pas traiter tous les arguments de la ligne de commande,
     je suppose donc que c'est un nouveau pot a rajouter
  */

  if(argv[optind] != NULL)
    {
      i = optind;

      pot = fopen(chemin, "a");
      erreur(pot);

	 if(!pot)
	   return 0;

	 while(argv[i] != NULL)
	   {
		if (verif_login(argv[i],1,chemin,NULL) == 0)
		  {
		    fprintf( pot , "%s\n" , argv[i] );
		    printf("%s a ete ajoute.\n",argv[i]);
		  }
		else
		  printf("%s est un login inexistant ou deja present dans votre liste.\n",argv[i]);
		i++;
	   }

	 fclose(pot);
    }

  return 1;
}

/* fonction principal */
int main(int argc , char *argv[] /*, char *envp[]*/)
{
  /* initialisation des variables */
  char *chemin;
  FILE *pot;

  /* recueil du chemin de pot.pot et de pot.pot.linux */
  if ( ( chemin = (char *) malloc(sizeof(char)*(strlen(getenv("HOME")) + 20)) ) == NULL )
    {
      fprintf( stderr , "Allocation de memoire impossible" );
      return -1;
    }

  strcpy ( chemin , getenv("HOME") );
  strcat ( chemin , "/.pot.pot" );

  if(reconnaissance_options(argc,argv,chemin) == -1)
    {
	 exit(EXIT_FAILURE);
    }

  if ((pot = fopen(chemin, "r")) == NULL)
    {
      fprintf(stderr,"~/.pot.pot n'existe pas.\n"
	      "Pour plus d'informations tapez : pot -h\n");
	 exit(EXIT_FAILURE);
    }

  if(IS_OPTION_SET(OPTION_LISTEPOTS))
    {
	 view(chemin);
	 return(EXIT_SUCCESS);
    }

  if(IS_OPTION_SET(OPTION_GTK))
    potgtk(chemin , argc , argv);
  else
    console ( chemin );

  return 0;
}




